{$A+,B-,D+,E+,F+,I+,L-,N-,O+,R+,S+,V+}
{$M 16384,0,655360}

program QuikLoad;

uses Dos, Crt, Marek;

const Hodnota : Array[1..8] of Byte = (128, 64, 32, 16, 8, 4, 2, 1);

type Siet = array[1..8, 1..16] of Boolean;

var  I, J, K: Integer;
     Mriezka: Siet;
  MenoSuboru: String;
   TypSuboru: Byte;
        Hodn: array[1..16] of byte;
    Subor: File of Siet;
        r: registers;   

procedure Skonci(Sprava: String);
begin
 Sound(1200);
 Delay(600);
 NoSound;
 Writeln(' FATAL: ' + Sprava);
 Writeln;
 Halt(255);
end;

function UpStr(S: String): String;
var St: String; I: Byte;
begin
 St := '';
 for I := 1 to Length(S) do St := St + UpCase(S[I]);
 UpStr := St;
end;

begin
 Writeln;
 Writeln;
 Writeln('QUIKLOAD  for  VGA adapters');
 Writeln('---------------------------');
 Writeln;
 InitZvuk;
 if ParamCount = 0 then Skonci('font name missing');
 if not Exist(ParamStr(1)) then
  Skonci('file ''' + ParamStr(1) + ''' not found');
 {---}
 MenoSuboru := UpStr(ParamStr(1));
 Assign(Subor, MenoSuboru);
 Reset(Subor);
 Writeln('    Font name : ' + MenoSuboru);
 Writeln;
 Writeln('--------------------------------');
 Writeln;
 for I := 1 to 94 do
    begin
      Read(Subor, Mriezka);
      for J := 1 to 16 do
        begin
         Hodn[J] := 0;
         for K := 1 to 8 do if Mriezka[K, J] then Inc(Hodn[J], Hodnota[K]);
        end;
      r.ah := $11;
      r.al := $00;
      r.bl := 0;
      r.bh := 16;
      r.cx := 1;
      r.dx := I + 32;
      r.es := seg(Hodn);
      r.bp := ofs(Hodn);
      Intr($10, r);
    end;
 Close(Subor); 
 Writeln;
 Zvuk;
 Writeln(MenoSuboru + ' was loaded into Video RAM.');
 Writeln;
end.


